.. _references:

References
============

.. rubric:: References

.. [BandwidthAuthorityMeasurements] https://gitlab.torproject.org/legacy/trac/-/wikis/doc/BandwidthAuthorityMeasurements
.. [Bornhack2018] https://juga0.github.io/onbasca_hax_slides/
.. [BridgeBwScanner] https://gitlab.com/DrPeterVanNostrand/bridge-bwscanner
.. [BwAuthFiles] https://bwauth.ritter.vg/bwauth/
.. [BwAuthKey] https://trac.torproject.org/projects/tor/query?status=!closed&keywords=~tor-bwauth
.. [BwAuthMex] https://trac.torproject.org/projects/tor/wiki/org/meetings/2018MexicoCity/Notes/BandwidthScanner
.. [BwAuthRome] https://trac.torproject.org/projects/tor/wiki/org/meetings/2018Rome/Notes/BandwidthAuthorityRequirements
.. [BwAuthTools] https://tomrittervg.github.io/bwauth-tools/
.. [BwAuthWiki] https://trac.torproject.org/projects/tor/wiki/doc/BandwidthAuthority
.. [BwscannerCode] https://github.com/TheTorProject/bwscanner
.. [BwscannerTwoHops] https://github.com/TheTorProject/bwscanner/blob/develop/bwscanner/circuit.py#L101
.. [BandwidthFileSpec] https://spec.torproject.org/bandwidth-file-spec/
.. [bandwidth_authorities_timeline] https://gitlab.torproject.org/tpo/network-health/bandwidth-authorities/-/wikis/bandwidth%20authorities%20timeline#data-about-bwauths
.. [bwauthstatus] https://consensus-health.torproject.org/#bwauthstatus
.. [ConsensusImg] https://jordan-wright.com/blog/images/blog/how_tor_works/consensus.png
.. [DIRSPEC2337] https://spec.torproject.org/dir-spec/consensus-formats.html
.. [DIRSPEC427] https://spec.torproject.org/dir-spec/server-descriptor-format.html
.. [GLOSSARYSPEC] https://gitweb.torproject.org/torspec.git/tree/glossary.txt
.. [GraphsHistorical] https://ritter.vg/misc/bwauth-historical/graphs-historical.html
.. [issues21882] https://gitlab.torproject.org/legacy/trac/-/issues/21882
.. [MetricsBw] https://metrics.torproject.org/bandwidth.html
.. [MetricsDirAuths] https://metrics.torproject.org/rs.html#search/flag:Authority
.. [MetricsGlossary] https://metrics.torproject.org/glossary.html
.. [MetricsTask2394] https://gitweb.torproject.org/metrics-tasks.git/tree/task-2394
.. [MetricsWeight] https://metrics.torproject.org/rs.html#map_consensus_weight_to_bandwidth
.. [MetricsPerf] https://metrics.torproject.org/torperf.html
.. [mlBwProgressDec1] https://lists.torproject.org/pipermail/tor-dev/2017-December/012703.html
.. [mlBwProgressDec2] https://lists.torproject.org/pipermail/tor-dev/2017-December/012714.html
.. [onbasca] https://tpo.pages.torproject.net/network-health/onbasca/
.. [OnionperfCode] https://github.com/robgjansen/onionperf
.. [PeerflowPaper] https://ohmygodel.com/publications/peerflow-popets2017.pdf
.. [PerformanceMetrics] https://gitlab.torproject.org/tpo/network-health/team/-/wikis/Tor-network-health-work#balancing-metrics
.. [PerformanceWork] https://gitlab.torproject.org/tpo/network-health/team/-/wikis/Tor-network-health-work#performance-work
.. [PIDcontr] https://en.wikipedia.org/wiki/PID_controller
.. [pytorctlCode] https://gitweb.torproject.org/pytorctl.git/
.. [sbwsBSD] https://github.com/juga0/sbws_openbsd
.. [sbwsCode] https://gitlab.torproject.org/tpo/network-health/sbws
.. [sbwsDeb] https://salsa.debian.org/pkg-privacy-team/sbws
.. [sbwsDia] https://sbws.readthedocs.io/en/latest/code_design.html
.. [sbwsDoc] https://sbws.readthedocs.io
.. [shadow] https://shadow.github.io/
.. [stdev] https://en.wikipedia.org/wiki/Standard_deviation
.. [stdscore] https://en.wikipedia.org/wiki/Standard_score
.. [StemCode] https://gitweb.torproject.org/stem.git
.. [Ticket13630] https://trac.torproject.org/projects/tor/ticket/13630
.. [Ticket2394] https://trac.torproject.org/projects/tor/ticket/2394
.. [Ticket24674] https://trac.torproject.org/projects/tor/ticket/24674
.. [TOR1] https://gitlab.torproject.org/tpo/core/tor/-/blob/769fa450edd5f9f0f953e369d367bdff09e63350/doc/man/tor.1.txt
.. [TorflowBwAuthorities] https://gitlab.torproject.org/tpo/network-health/torflow/-/blob/main/NetworkScanners/BwAuthority/README.BwAuthorities
.. [TorflowCode] https://gitweb.torproject.org/torflow.git
.. [TorflowComp] https://trac.torproject.org/projects/tor/query?status=!closed&component=Core+Tor%2Ftorflow
.. [TorflowMap] https://torflow.uncharted.software/#/2016-1-13?ML=-42,40,3
.. [TorflowPaper] https://research.torproject.org/techreports/torflow-2009-08-07.pdf
.. [TorflowREADME] https://gitlab.torproject.org/tpo/network-health/torflow/-/blob/main/README
.. [TORFLOWSPEC] https://gitlab.torproject.org/tpo/network-health/torflow/-/tree/main/NetworkScanners/BwAuthority/README.spec.txt
.. [TORFLOWSPEC332] https://gitlab.torproject.org/tpo/network-health/torflow/-/tree/main/NetworkScanners/BwAuthority/README.spec.txt#n332
.. [TORFLOWSPEC447] https://gitlab.torproject.org/tpo/network-health/torflow/-/tree/main/NetworkScanners/BwAuthority/README.spec.txt#n447
.. [TorperfCode] https://gitweb.torproject.org/torperf.git
.. [torTests] https://gitlab.torproject.org/tpo/core/tor/-/blob/769fa450edd5f9f0f953e369d367bdff09e63350/doc/HACKING/WritingTests.md
.. [Twisted] https://twistedmatrix.com
.. [txtorcon] https://github.com/meejah/txtorcon
.. [WPToken] https://en.wikipedia.org/wiki/Token_Bucket
.. [WPThroughput] https://en.wikipedia.org/wiki/Throughput
.. [WPBandwidthThrottling] https://en.wikipedia.org/wiki/Bandwidth_throttling#Throttling_vs._capping